REM SUB '*******   PH  TDS      ***************
REM ' ver 1.6 20.02.17
REM '****************************************************
REM '  BASIC DEVICE 3.4.8  
REM '****************************************************
REM '			 
REM 'I/O 1     #4,   
REM 'I/O 2      ,   
REM 'I/O 3     #1 
REM 'I/O 4     #2
REM 'I/O 5     #3
REM 'I/O 6   ,   
REM 'I/O 7     ,   
REM 'I/O 8   
REM 'I/O 9    
REM 'I/O 10     ,  
REM 'I/O 11    ,   
REM 'UART     pH, EC/TDC


REM '  
#define PUMP_1_ON   EQU    PORT 3,1 
#define PUMP_1_OFF  EQU    PORT 3,0
#define PUMP_1_IN  EQU    PORT*{3}

#define PUMP_2_ON   EQU    PORT 4,1 
#define PUMP_2_OFF  EQU    PORT 4,0
#define PUMP_2_IN  EQU    PORT*{4} 

#define PUMP_3_ON   EQU    PORT 5,1 
#define PUMP_3_OFF  EQU    PORT 5,0
#define PUMP_3_IN  EQU    PORT*{5} 

#define PUMP_4_ON   EQU    PORT 1,1 
#define PUMP_4_OFF  EQU    PORT 1,0
#define PUMP_4_IN  EQU    PORT*{1} 

REM '     
#define PUMP_IN_ON  EQU    PORT 2,1 
#define PUMP_IN_OFF EQU    PORT 2,0 
#define PUMP_IN_IN  EQU    PORT*{2} 

REM '     
#define PUMP_TANK_ON  EQU    PORT 9,1 
#define PUMP_TANK_OFF EQU    PORT 9,0 
#define PUMP_TANK_IN EQU    PORT*{9} 

REM '    -  
#define WATER_ON  EQU    PORT 11,1 
#define WATER_OFF EQU    PORT 11,0 
#define WATER_IN EQU    PORT*{11}

REM ' 
#define HEATER_ON  EQU    PORT 6,1 
#define HEATER_OFF EQU    PORT 6,0 
#define HEATER_IN EQU    PORT*{6} 

REM ' ***************************************************
REM '   ,    - 
REM '   IN=0  IN=1
#define INPUT_LO  EQU    PORT{10}
#define INPUT_HI  EQU    PORT{7}


REM ' ***************************************************
REM '      BASIC 
REM '****************************************************
REM ENDSUB  '********************************************


REM SUB  ' *********   VARIABLE  Timer ******************
REM '	TIMER_1    
REM '	TIMER_2     EC
REM '   TIMER_3    PH
REM '   TIMER_4    EC
REM '   TIMER_5    TERMO
REM '   TIMER_6    TANK ADD WATER
REM '   TIMER_7   
REM '   TIMER_0 

REM '      *********   VARIABLE  MEMORY 16 bit  *********

REM ' A -      PH
REM ' 00.0- 50.0; 99.9 - ERROR
REM ' B -      EC
REM ' 00.0- 50.0; 99.9 - ERROR
REM ' C -    
REM ' 00.0- 50.0; 99.9 - ERROR
REM ' D -   

REM ' E -   EC 00.00- 10.00; 99.99 - ERROR
REM ' F -   EC
REM ' G -   EC

REM ' H -   PH 00.00- 15.00; 99.99 - ERROR
REM ' I -   PH
REM ' J -   PH 

REM ' K -     1  PH ()
REM ' L -     1  PH ()
REM ' M -     2  PH 
REM ' N -     2  PH 

REM ' O -   EC  10 
REM ' P -   EC
REM ' Q -  1  EC
REM ' R -  2  EC
REM ' S -  3  EC

REM ' T -    
REM '     (  PH/EC/INT  )

REM ' U -     EC  
REM ' V -     EC  

REM ' W -     - 
REM ' X -     EC - 

REM ' Y -  -   
REM ' Z -  -   

REM '  -    
REM ' b -    

REM ' c
REM ' d
REM ' e
REM ' f
REM ' g
REM ' h

REM ' i -  
REM ' ******* 8 bit *************************************

REM '#(600) CONFIF STATUS 
REM '       = 73 - ok, ELSE Bad CONFIG 

REM '       
REM '#(601) -   
REM '       - 0 -  1 - 
REM '#(602) -    NOT USE
REM '       - 0 -  1 - 

REM '      
REM '#(603) - 0 -  1 - ( )
REM '#(604) -   
REM '       - 0 INT; 1 - PH; 2 - EC 
REM '#(605) -   
REM '       - 0 -  1 - 

REM '       PH
REM '#(606) - 0 -  1 - ( )
REM '#(607) - 0   #1  #4   
REM '         1   #1   
REM '         2   #1   
REM '#(608) -   
REM '       - 0 -  1 - 
REM '#(609) -   
REM '       - 0 -  1 - 

REM '      EC
REM '#(610) - 0 -  1 - ( )
REM '#(611) - 0 -  1 - ( PH)
REM '#(612) - 2     #2  #3    
REM '         1     #2
REM '         3     #2  #3  #4
REM '#(613) -   
REM '       - 0 -  1 - 
REM '#(614) -   
REM '       - 0 -  1 - 

REM ' ********   end Config  ****************************

REM '#(650) -    EC
REM '   =0 -  
REM '   =1 -  ,    
REM '   =2 -      
REM '   =3 -   
REM '   =4 -    
REM '   =5 -   
REM '   =6 -  
REM '   =7 -   1
REM '   =8 -   2
REM '   =9 -   3
REM '   =10 - 


REM '#(651) -    PH
REM '   =0 -  
REM '   =1 -  ,    
REM '   =2 -  
REM '   =3 -  
REM '   =4 -     ->2 OR ->1


REM '#(652) -   
REM '   =0 - 
REM '   =1 - 

REM '#(653) -    
REM '   =0 -  
REM '   =1 -  ,    
REM '   =2 -  
REM '   =3 -  
REM '   =4 -     

REM '#(654) -    
REM '#(655) - FLAG PH 
REM '#(656) - FLAG EC
REM '#(657) - FLAG TERMO
REM '#(658) - FLAG DISPLAY


REM '#(700) - #(764)  
REM '#(765) -  

REM '#(770) - #(789)  
REM '#(790) - #(799)  
REM '#(800) - #(809)  
REM ENDSUB  '********************************************

REM SUB ' ************ RAM  *****************************
REM '     
REM '#(992) -  USE
REM '****************************************************
REM ENDSUB  '********************************************


0000
[RESET]
CLR:NOERR 1:GOTO [START]
REM 'CLR:GOTO [START]
REM '**    
0001
CLR:LINIT 1:LPRINT "RESTART":PAUSE 1000:NOERR 1
REM ' DEBUG
STOP:GOTO [START]

REM '****************************************************
REM '   TANK_CONTROL.BAS
REM '       
REM '****************************************************

REM '****************************************************
REM '[INIT_TANK]
REM 'AT 64:LPRINT "Init TANK MODULE":RETURN
REM '****************************************************
REM '****************************************************
[TANK_WORK]
REM '       
REM '#(601) -   
REM '       - 0 -  1 - 

IF #(601)=0 THEN PUMP_TANK_ON:GOTO [TANK_WORK_1] 
REM '  -    
REM ' b -    
REM '   TIMER_7   
IF 0<>TIMER{7} THEN GOTO [TANK_WORK_1]
REM '#(652) -   
REM '   =0 -   =1 - 
IF #(652)=0 THEN #(652)=1:TIMER 7,a:PUMP_TANK_ON:GOTO [TANK_WORK_1]  
IF #(652)=1 THEN #(652)=0:TIMER 7,b:PUMP_TANK_OFF
[TANK_WORK_1]
REM '   . - ; . - ON
IF 1=INPUT_HI THEN PUMP_IN_OFF:IF #(650)=2 THEN #(650)=3
IF 1=INPUT_LO THEN PUMP_IN_ON
REM '     
REM '         
REM '       

REM '#(650) -    EC
REM '   =2 -      
IF #(650)<>2 THEN RETURN
IF 0<>TIMER{6} THEN RETURN
#(650)=3:PUMP_IN_OFF:RETURN
REM '****************************************************

[TANK_ENABLE_MIX]
#(652)=1:TIMER 7,a:PUMP_TANK_ON:RETURN
REM '****************************************************


REM '****************************************************
[TANK_ADD_WATER]
REM '     EC 
REM '   TIMER_6    TANK
REM ' U -     EC  
TIMER 6,U:PUMP_IN_ON:RETURN
REM '****************************************************

REM '****************************************************
REM '        
REM '****************************************************
[POLIW_WORK]
REM '     . 
REM '     ,     
REM '    [POLIW_BLOCK] - 1  !!!
REM '     ,   .
IF 0=TIMER{1} THEN WATER_ON:RETURN
REM '****************************************************
REM '****************************************************
[POLIW_BLOCK]
REM '   ,   
REM ' W -     - 
REM '	TIMER_1    
IF 0<>TIMER{1} THEN RETURN
TIMER 1,W:WATER_OFF:RETURN
REM '****************************************************
REM '****************************************************

REM '****************************************************
[MENU_TANK]
REM '       
REM '#(601) -   
REM '       - 0 -  1 - 
REM '  -    
REM ' b -    

REM ' W -     - 
[MENU_TANK_1]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_TANK_1]  
LPRINT " -":AT 64:LPRINT ""
AT 64:IF #(601)=1 THEN LPRINT " "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_TANK_2]
#(601)=((!#(601))&1):GOTO [MENU_TANK_1]

[MENU_TANK_2]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_TANK_2] 
LPRINT " ":AT 64:LPRINT "   ",a," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_TANK_3]
i=a:GOSUB [CHANGE_PARAM]
a=i:GOTO [MENU_TANK_2]

[MENU_TANK_3]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_TANK_3] 
LPRINT " ":AT 64:LPRINT "   ",b," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_TANK_4]
i=b:GOSUB [CHANGE_PARAM]
b=i:GOTO [MENU_TANK_3]

[MENU_TANK_4]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_TANK_4] 
LPRINT ".  ":AT 64:LPRINT "   ",W," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_TANK_5]
i=W:GOSUB [CHANGE_PARAM]
W=i:GOTO [MENU_TANK_4]

[MENU_TANK_5]
GOTO [SAVE_CONFIG]
REM 'RETURN ********************************************













REM '****************************************************
REM '   TERMO_CONTROL.BAS
REM '        
REM '****************************************************

REM '****************************************************
[INIT_TERMO]
AT 64:LPRINT "Init TERMO MODUL":HEATER_OFF
REM '    
IF #(604)=0 THEN GOSUB [GET_TERMO]
IF #(604)=0 THEN IF C>500 THEN AT 64:LPRINT "T error"
IF #(604)=1 THEN IF A>500 THEN AT 64:LPRINT "T error"
IF #(604)=2 THEN IF B>500 THEN AT 64:LPRINT "T error"
RETURN
REM '****************************************************

REM '****************************************************
[GET_TERMO]
C=GTEMP{1}:STEMP 1:IF C>0 THEN IF C<500 THEN RETURN
C=999:RETURN
REM '****************************************************

REM '****************************************************
[GET_T]
IF #(604)=0 THEN GOSUB [GET_TERMO]
IF #(604)=0 THEN T=500:IF C<500 THEN T=C:RETURN
IF #(604)=1 THEN GOSUB [GET_PH_TEMP]
IF #(604)=1 THEN T=500:IF A<500 THEN T=A:RETURN
IF #(604)=2 THEN GOSUB [GET_EC_TEMP]
IF #(604)=2 THEN T=500:IF B<500 THEN T=A:RETURN
RETURN
REM '****************************************************

REM '****************************************************
[TERMO_WORK]
REM '  ,   ? 
REM '#(603) - 0 -  1 - ( )
REM '   ,  
IF #(603)=0 THEN HEATER_OFF:RETURN
REM '****************************************************
[TERMO_WORK_GO]
REM ' 
#(653)=#(653)&3:IF #(653)=0 THEN #(653)=1

IF #(653)<>1 THEN GOTO [TERMO_WORK_GO_1]
REM '     5     
REM '   
=SEC{}:IF 0<>%5 THEN #(657)=0:RETURN 
[TERMO_WORK_GO_ST]
IF #(657)=1 THEN RETURN
#(657)=1:GOSUB [GET_T]
IF T>500 THEN RETURN
REM ' D -   
IF T>D THEN #(653)=1:RETURN
REM '   

REM '#(605) -   
REM '       - 0 -  1 - 
IF #(605)=1 THEN GOSUB [TANK_ENABLE_MIX]
REM '   TIMER_5    TERMO
REM ' Y -  -   
HEATER_ON:TIMER 5,Y:#(653)=2:RETURN

REM '****************************************************
[TERMO_WORK_GO_1]
IF #(653)<>2 THEN GOTO [TERMO_WORK_GO_2]
IF 0<>TIMER{5} THEN RETURN
REM ' Z -  -   
HEATER_OFF:TIMER 5,Z:#(653)=3:RETURN

REM '****************************************************
[TERMO_WORK_GO_2]
IF 0<>TIMER{5} THEN RETURN
#(653)=4:GOTO [TERMO_WORK_GO_ST]
REM '****************************************************

REM '****************************************************
[MENU_TERMO]
REM '      
REM '#(603) - 0 -  1 - ( )
REM '#(604) -   
REM '       - 0 INT; 1 - PH; 2 - EC 
REM '#(605) -   
REM '       - 0 -  1 - 

REM ' D -   

REM ' Y -  -   
REM ' Z -  -   

[MENU_TERMO_1]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_TERMO_1]  
LPRINT " .":AT 64:LPRINT ""
AT 64:IF #(603)=1 THEN LPRINT " "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_TERMO_2]
#(603)=((!#(603))&1):GOTO [MENU_TERMO_1]

[MENU_TERMO_2]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_TERMO_2]  
LPRINT " .":AT 64:LPRINT ""
AT 64:IF #(604)=1 THEN LPRINT "  PH "
IF #(604)=2 THEN LPRINT "  EC "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_TERMO_3]
#(604)=#(604)+1:IF #(604)>2 THEN #(604)=0
GOTO [MENU_TERMO_2]

[MENU_TERMO_3]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_TERMO_3]  
LPRINT "..":AT 64:LPRINT "- : ."
AT 71:IF #(605)=1 THEN LPRINT ". "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_TERMO_4]
#(605)=((!#(605))&1):GOTO [MENU_TERMO_3]

REM ' D -   
[MENU_TERMO_4]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_TERMO_4] 
IF D<50 THEN D=50 
LPRINT ". ":AT 64:IF D>500 THEN D=500 
LPRINT .1,%3," ",D,"  "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_TERMO_5]
i=D:GOSUB [CHANGE_PARAM]
D=i:GOTO [MENU_TERMO_4]

REM ' Y -  -   
[MENU_TERMO_5]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_TERMO_5]
LPRINT " ":AT 64:LPRINT "   ",Y," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_TERMO_6]
i=Y:GOSUB [CHANGE_PARAM]
Y=i:GOTO [MENU_TERMO_5]

REM ' Z -  -   
[MENU_TERMO_6]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_TERMO_6]
LPRINT " .":AT 64:LPRINT "   ",Z," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [SAVE_CONFIG]
i=Z:GOSUB [CHANGE_PARAM]
Z=i:GOTO [MENU_TERMO_6]

REM 'RETURN**********************************************























REM '****************************************************
REM '   PH_CONTROL.BAS
REM '        PH   "0"
REM '****************************************************

REM '****************************************************
[INIT_PH]
AT 64:LPRINT "Init PH MODULE  ":PUMP_1_OFF:PUMP_4_OFF
REM '   5 CEK
SPRINT "0MD0":PAUSE 100:SPRINT "0IT5":PAUSE 6000 
GOSUB [GET_PH]
GOTO [GET_PH_TEMP]
REM 'RETURN *********************************************

REM '****************************************************
REM ' H -   PH 00.00- 15.00; 99.99 - ERROR
REM '  
[GET_PH]
SPRINT "0GT0":PAUSE 50:SGET #(700)
IF #(700)=0 THEN H=9999:RETURN
#(765)=INSTR${$(700),"H="}
IF #(765)=0 THEN H=9999:RETURN
#(765)=#(765)+2:H=VAL{$(700),#(765)}:RETURN
REM '****************************************************

REM '****************************************************
REM ' A -      PH
REM '    A = 00.0- 50.0; 99.9 - ERROR
[GET_PH_TEMP]
SPRINT "0GT1":PAUSE 50:SGET #(700)
IF #(700)=0 THEN A=999:RETURN
#(765)=INSTR${$(700),"T="}:#(765)=#(765)+2
IF #(765)=2 THEN A=999:RETURN
A=VAL{$(700),#(765)}:IF A>500 THEN A=999:RETURN 
RETURN
REM '****************************************************

REM '****************************************************
[PH_WORK]
REM ' DEBUG
REM 'PAUSE 100:=TIMER{3}:PRINT #(651),"-",

REM '  ,   ? 
IF #(606)=1 THEN GOTO [PH_WORK_GO]
REM '  ,    
#(651)=0:PUMP_1_OFF
IF #(607)=0 THEN IF #(612)<>3 THEN PUMP_4_OFF
RETURN

REM '****************************************
[PH_WORK_GO]
REM ' 
IF #(651)=0 THEN #(651)=1
IF #(651)<>4 THEN IF #(651)<>1 THEN GOTO [PH_WORK_GO_1]

REM '  #(651)=1 OR =4 -  ,    
REM '     5     
REM '   
=SEC{}:IF 0<>%5 THEN #(655)=0:RETURN 
REM '   5 
[PH_WORK_GO_ST]
IF #(655)=1 THEN RETURN
#(655)=1:GOSUB [GET_PH]
IF H>9000 THEN RETURN

CASE #(607),0,[PH_START_0],1,[PH_START_1],2,[PH_START_2]:RETURN
REM 'RETURN 
REM '****************************************
REM '#(607) - 0   #1  #4 
REM '   TIMER_3    PH
[PH_START_0]
IF H>J THEN PUMP_1_ON:TIMER 3,K:GOTO [PH_START_0_1]
IF H<I THEN PUMP_4_ON:TIMER 3,M:GOTO [PH_START_0_1]
REM '#(611) - 0 -  1 - ( PH)
#(651)=1:#(611)=1:RETURN
REM '************************
REM '         1   #1  
[PH_START_1]
IF H>J THEN PUMP_1_ON:TIMER 3,K:GOTO [PH_START_0_1]
#(651)=1:#(611)=1:RETURN
REM '************************
REM '         2   #1   
[PH_START_2]
IF H<I THEN THEN PUMP_1_ON:TIMER 3,K:GOTO [PH_START_0_1]
#(651)=1:#(611)=1:RETURN
REM '****************************************
[PH_START_0_1]
REM '#(609) -   
REM '       - 0 -  1 - 
IF #(609)=1 THEN GOSUB [TANK_ENABLE_MIX]
REM '   - 
IF #(651)=4 THEN #(651)=2:RETURN 
REM '   1   " "
#(651)=2
REM '#(608) -   
REM '       - 0 -  1 -  
IF #(608)=1 THEN GOSUB [POLIW_BLOCK]
REM '#(611) - 0 -  1 - ( PH)
REM ' X -     EC - 
REM '	TIMER_2     EC
#(611)=0:TIMER 2,X:RETURN 



REM '****************************************************
[PH_WORK_GO_1]
REM '   
IF #(651)<>2 THEN GOTO [PH_WORK_GO_2] 
IF 0<>TIMER{3} THEN RETURN
CASE #(607),0,[PH_START_0A],1,[PH_START_1A],2,[PH_START_1A]:RETURN
REM 'RETURN 

[PH_START_0A]
IF 1=PUMP_1_IN THEN TIMER 3,L:PUMP_1_OFF
IF 1=PUMP_4_IN THEN TIMER 3,N:PUMP_4_OFF
#(651)=3:RETURN 

[PH_START_1A]
TIMER 3,L:PUMP_1_OFF:#(651)=3:RETURN 

REM '****************************************************
[PH_WORK_GO_2]
IF 0<>TIMER{3} THEN RETURN
#(651)=4:GOTO [PH_WORK_GO_ST]
REM '****************************************************



REM '****************************************************
[MENU_PH]
REM '       PH
REM '#(606) - 0 -  1 - ( )
REM '#(607) - 0   #1  #4   
REM '         1   #1   
REM '         2   #1   
REM '#(608) -   
REM '       - 0 -  1 - 
REM '#(609) -   
REM '       - 0 -  1 - 
[MENU_PH_1]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_1]  
LPRINT " PH":AT 64:LPRINT ""
AT 64:IF #(606)=1 THEN LPRINT " "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_2]
#(606)=((!#(606))&1):GOTO [MENU_PH_1]

[MENU_PH_2]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_2]  
LPRINT ". ":AT 64:LPRINT "PH  "
AT 64:IF #(607)=1 THEN LPRINT "  ."
IF #(607)=2 THEN LPRINT "  ."
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_3]
#(607)=#(607)+1:IF #(607)>2 THEN #(607)=0
GOTO [MENU_PH_2]

[MENU_PH_3]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_3]  
LPRINT ". ":AT 64:LPRINT "PH ."
AT 64:IF #(608)=1 THEN LPRINT "PH . "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_4]
#(608)=((!#(608))&1):GOTO [MENU_PH_3]


[MENU_PH_4]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_4]  
LPRINT "..":AT 64:LPRINT "PH - : "
IF #(609)=0 THEN LPRINT "."
IF #(609)=1 THEN LPRINT "."
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_5]
#(609)=((!#(609))&1):GOTO [MENU_PH_4]

REM ' K -     1  PH ()
REM ' L -     1  PH ()
REM ' M -     2  PH 
REM ' N -     2  PH 
REM ' X -     EC - 
[MENU_PH_5]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_5]
LPRINT ".  #1":AT 64:LPRINT "PH ",K," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_6]
i=K:GOSUB [CHANGE_PARAM]
K=i:GOTO [MENU_PH_5]

[MENU_PH_6]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_6]
LPRINT ".  #1":AT 64:LPRINT "PH ",L," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_7]
i=L:GOSUB [CHANGE_PARAM]
L=i:GOTO [MENU_PH_6]

[MENU_PH_7]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_7]
LPRINT ".  #2":AT 64:LPRINT "PH ",M," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_8]
i=M:GOSUB [CHANGE_PARAM]
M=i:GOTO [MENU_PH_7]

[MENU_PH_8]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_8]
LPRINT ".  #2":AT 64:LPRINT "PH ",N," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_9]
i=N:GOSUB [CHANGE_PARAM]
N=i:GOTO [MENU_PH_8]

REM ' X -     EC - 
[MENU_PH_9]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_9]
LPRINT ". EC ":AT 64:LPRINT "  ",X," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_10]
i=X:GOSUB [CHANGE_PARAM]
X=i:GOTO [MENU_PH_9]

REM ' I -   PH
REM ' J -   PH 
[MENU_PH_10]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_10]
LPRINT " PH":AT 70:IF I>1500 THEN I=1500
LPRINT .2,I:#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_11]
i=I:GOSUB [CHANGE_PARAM]
I=i:GOTO [MENU_PH_10]

[MENU_PH_11]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_11]
LPRINT " PH":AT 70:IF J>1500 THEN J=1500
LPRINT .2,J:#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_12]
i=J:GOSUB [CHANGE_PARAM]
J=i:GOTO [MENU_PH_11]

[MENU_PH_12]
GOSUB [SAVE_CONFIG]

DATA $(770),".PH 7.01":DATA $(790),"0CL4":GOSUB [KALIBR_PH_SUB]
IF i=0 THEN RETURN
DATA $(770),".PH 4.01":DATA $(790),"0CL6":GOSUB [KALIBR_PH_SUB]
IF i=0 THEN RETURN
DATA $(770),".PH 10.01":DATA $(790),"0CL7":GOTO [KALIBR_PH_SUB]
REM 'RETURN ***********************************************


[KALIBR_PH_SUB]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [KALIBR_PH_SUB]
LPRINT *$(770):PAUSE 1000:CLS:GOSUB [GET_PH]
LPRINT .2,%4,"PH=",H:AT 64:LPRINT "Ok-,->"  
#(765)=KEY{30}:IF #(765)=0 THEN i=0:RETURN
IF #(765)=4 THEN i=1:RETURN
IF #(765)<>1 THEN GOTO [KALIBR_PH_SUB]
SPRINT *$(790):CLS:LPRINT "Ok":PAUSE 1000:GOTO [KALIBR_PH_SUB]





REM '****************************************************
REM '   EC_CONTROL.BAS
REM '        EC   "1"
REM '****************************************************


REM '****************************************************
[INIT_EC]
AT 64:LPRINT "Init EC MODULE  ":PUMP_2_OFF:PUMP_3_OFF
REM '   5 CEK
PUMP_4_OFF:SPRINT "1MD0":PAUSE 50:SPRINT "1IT5"
PAUSE 6000:GOSUB [GET_EC]
GOTO [GET_EC_TEMP]
REM 'RETURN *********************************************


REM '****************************************************
REM ' E -   EC 00.00- 10.00; 99.99 - ERROR
REM '  
[GET_EC]
SPRINT "1GT0":PAUSE 50:SGET #(700)
IF #(700)=0 THEN E=9999:RETURN
#(765)=INSTR${$(700),"E="}
IF #(765)=0 THEN E=9999:RETURN
#(765)=#(765)+2:E=VAL{$(700),#(765)}:E=E/10:RETURN
REM '****************************************************

REM '****************************************************
REM ' B -      EC
REM '    A = 00.0- 50.0; 99.9 - ERROR
[GET_EC_TEMP]
SPRINT "1GT1":PAUSE 50:SGET #(700)
IF #(700)=0 THEN B=999:RETURN
#(765)=INSTR${$(700),"T="}
IF #(765)=0 THEN B=999:RETURN
#(765)=#(765)+2:B=VAL{$(700),#(765)}
IF B>500 THEN B=999:RETURN 
RETURN
REM '****************************************************

REM '****************************************************
[EC_WORK]
REM '#(610) - 0 -  1 - ( )
REM '  ,   ? 
IF #(610)=1 THEN GOTO [EC_WORK_1]
REM '  ,    
#(650)=0:PUMP_2_OFF:PUMP_3_OFF
IF #(612)=3 THEN PUMP_4_OFF
RETURN

REM '#(611) - 0 -  1 - ( PH)
[EC_WORK_1]
IF 0=TIMER{2} THEN #(611)=1
IF #(611)=1 THEN GOTO [EC_WORK_GO]
#(650)=6:PUMP_2_OFF:PUMP_3_OFF
IF #(612)=3 THEN PUMP_4_OFF
RETURN

REM '****************************************
[EC_WORK_GO]

REM ' 
IF #(650)=0 THEN #(650)=1


IF #(650)<>5 THEN IF #(650)<>1 THEN GOTO [EC_WORK_GO_1]
REM ' #(650)=1 -  ,    
REM '     5     
REM '   
=SEC{}:IF 0<>%5 THEN #(656)=0:RETURN 

[EC_WORK_GO_ST]
IF #(656)=1 THEN RETURN
#(656)=1:GOSUB [GET_EC]
IF E>9000 THEN RETURN
IF E>=F THEN IF E<=G THEN #(650)=1:RETURN

IF E<F THEN GOTO [EC_WORK_GO_MIN]
REM '    - 
REM '   =2 -      
REM ' U -     EC  
GOSUB [TANK_ADD_WATER]
REM '#(609) -   
REM '       - 0 -  1 - 
IF #(614)=1 THEN GOSUB [TANK_ENABLE_MIX]
IF #(650)=5 THEN #(650)=2:RETURN 
#(650)=2
REM '#(613) -   
REM '       - 0 -  1 -  
IF #(613)=1 THEN GOSUB [POLIW_BLOCK]
RETURN 

REM '****************************************************
[EC_WORK_GO_1]
IF #(650)=2 THEN RETURN
IF #(650)<>3 THEN GOTO [EC_WORK_GO_2]
REM '   TIMER_6    TANK ADD WATER
REM ' V -     EC  
TIMER 6,V:#(650)=4:RETURN

REM '****************************************************
[EC_WORK_GO_2]
REM '   =4 -    
IF #(650)<>4 THEN GOTO [EC_WORK_GO_3]
IF 0<>TIMER{6} THEN RETURN
#(650)=5:RETURN

REM '    -  
[EC_WORK_GO_MIN]
IF #(614)=1 THEN GOSUB [TANK_ENABLE_MIX]
REM '#(613) -   
REM '       - 0 -  1 -  
IF #(650)<>5 THEN IF #(613)=1 THEN GOSUB [POLIW_BLOCK] 
REM '    
REM ' O -   EC  10 
REM ' Q -  1  EC  
REM '   TIMER_4    EC
#(650)=7:=O*Q/10:TIMER 4,:PUMP_2_ON:RETURN

REM '****************************************************
[EC_WORK_GO_3]
IF #(650)<>7 THEN GOTO [EC_WORK_GO_4]
IF 0<>TIMER{4} THEN RETURN
REM '#(612) - 2     #2  #3    
REM '         1     #2
REM '         3     #2  #3  #4
PUMP_2_OFF
REM ' P -   EC
IF #(612)=1 THEN #(650)=10:TIMER 4,P:RETURN

REM ' R -  2  EC
REM ' O -   EC  10 
=O*R/10:TIMER 4,:PUMP_3_ON:#(650)=8:RETURN

REM '****************************************************
[EC_WORK_GO_4]
IF #(650)<>8 THEN GOTO [EC_WORK_GO_5]
IF 0<>TIMER{4} THEN RETURN
REM '#(612) - 2     #2  #3    
REM '         1     #2
REM '         3     #2  #3  #4
PUMP_3_OFF
REM ' P -   EC
IF #(612)=2 THEN #(650)=10:TIMER 4,P:RETURN

REM ' S -  3  EC
REM ' O -   EC  10 
=O*S/10:TIMER 4,:PUMP_4_ON:#(650)=9:RETURN

REM '****************************************************
[EC_WORK_GO_5]
IF #(650)<>9 THEN GOTO [EC_WORK_GO_6]
IF 0<>TIMER{4} THEN RETURN
REM ' P -   EC
PUMP_4_OFF:#(650)=10:TIMER 4,P:RETURN

REM '****************************************************
[EC_WORK_GO_6]
IF 0<>TIMER{4} THEN RETURN
#(650)=5:GOTO [EC_WORK_GO_ST]
REM '****************************************************






REM '****************************************************
[MENU_EC]

REM '      EC
REM '#(610) - 0 -  1 - ( )

REM '#(612) - 2     #2  #3    
REM '         1     #2
REM '         3     #2  #3  #4

REM '#(613) -   
REM '       - 0 -  1 - 
REM '#(614) -   
REM '       - 0 -  1 - 

[MENU_EC_1]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_1]  
LPRINT " EC":AT 64:LPRINT ""
AT 64:IF #(610)=1 THEN LPRINT " "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_2]
#(610)=((!#(610))&1):GOTO [MENU_EC_1]

[MENU_EC_2]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_2]  
LPRINT ". ":AT 64:LPRINT "EC  "
AT 64:IF #(612)=1 THEN LPRINT "EC        "
IF #(612)=3 THEN LPRINT "EC        "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_3]
#(612)=#(612)+1:IF #(612)>3 THEN #(612)=1
GOTO [MENU_EC_2]


[MENU_EC_3]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_3]  
LPRINT ". ":AT 64:LPRINT "EC  ."
AT 64:IF #(613)=1 THEN LPRINT "EC  . "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_4]
#(613)=((!#(613))&1):GOTO [MENU_EC_3]

[MENU_EC_4]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_4]  
LPRINT "..":AT 64:LPRINT "EC - : ."
AT 74:IF #(614)=1 THEN LPRINT ". "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_5]
#(614)=((!#(614))&1):GOTO [MENU_EC_4]




REM ' O -   EC  10 
REM ' P -   EC
REM ' Q -  1  EC
REM ' R -  2  EC
REM ' S -  3  EC

REM ' U -     EC  
REM ' V -     EC  

[MENU_EC_5]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_5]
LPRINT " 10/10":AT 64:LPRINT "  ",O," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_6]
i=O:GOSUB [CHANGE_PARAM]
O=i:GOTO [MENU_EC_5]

[MENU_EC_6]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_6]
LPRINT ".  EC":AT 64:LPRINT "  ",P," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_7]
i=P:GOSUB [CHANGE_PARAM]
P=i:GOTO [MENU_EC_6]

[MENU_EC_7]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_7]
LPRINT " - #1":AT 64:LPRINT "  ",Q,"/10"
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_8]
i=Q:GOSUB [CHANGE_PARAM]
Q=i:GOTO [MENU_EC_7]

[MENU_EC_8]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_8]
LPRINT " - #2":AT 64:LPRINT "  ",R,"/10"
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_9]
i=R:GOSUB [CHANGE_PARAM]
R=i:GOTO [MENU_EC_8]

[MENU_EC_9]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_9]
LPRINT " - #3":AT 64:LPRINT "  ",S,"/10"
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_10]
i=S:GOSUB [CHANGE_PARAM]
S=i:GOTO [MENU_EC_9]

REM ' U -     EC  
REM ' V -     EC  
[MENU_EC_10]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_10]
LPRINT ". . ":AT 64:LPRINT "EC ",U," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_11]
i=U:GOSUB [CHANGE_PARAM]
U=i:GOTO [MENU_EC_10]

[MENU_EC_11]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_11]
LPRINT ". . ":AT 64:LPRINT "EC ",V," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_12]
i=V:GOSUB [CHANGE_PARAM]
V=i:GOTO [MENU_EC_11]

[MENU_EC_12]
REM ' F -   EC
REM ' G -   EC
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_12]
LPRINT " EC":AT 70:IF F>1000 THEN F=1000
LPRINT .2,F:#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_13]
i=F:GOSUB [CHANGE_PARAM]
F=i:GOTO [MENU_EC_12]

[MENU_EC_13]

REM ' F -   EC
REM ' G -   EC
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_13]
LPRINT " EC":AT 70:IF G>1000 THEN G=1000
LPRINT .2,G:#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_14]
i=G:GOSUB [CHANGE_PARAM]
G=i:GOTO [MENU_EC_13]


[MENU_EC_14]

GOSUB [SAVE_CONFIG]

DATA $(770),".EC 1413":DATA $(790),"1CL0":GOSUB [KALIBR_EC_SUB]
IF i=0 THEN RETURN
DATA $(770),".EC 5000":DATA $(790),"1CL1":GOSUB [KALIBR_EC_SUB]
IF i=0 THEN RETURN
DATA $(770),".EC 12880":DATA $(790),"1CL2":GOTO [KALIBR_EC_SUB]
REM 'RETURN*********************************************


[KALIBR_EC_SUB]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [KALIBR_EC_SUB]
LPRINT *$(770):PAUSE 1000:CLS:GOSUB [GET_EC]
LPRINT .2,%4,"EC=",E:AT 64:LPRINT "Ok-,->"  
#(765)=KEY{30}:IF #(765)=0 THEN i=0:RETURN
IF #(765)=4 THEN i=1:RETURN
IF #(765)<>1 THEN GOTO [KALIBR_EC_SUB]
SPRINT *$(790):CLS:LPRINT "Ok":PAUSE 1000:GOTO [KALIBR_EC_SUB]




REM '****************************************************
REM '   CONTROL_SUB.BAS
REM '     
REM '****************************************************
[MANUAL_RUN]
IF 16=GKEY{} THEN PUMP_1_ON:GOTO [MANUAL_RUN] 
IF 1=GKEY{} THEN PUMP_2_ON:GOTO [MANUAL_RUN] 
IF 8=GKEY{} THEN PUMP_3_ON:GOTO [MANUAL_RUN] 
IF 2=GKEY{} THEN PUMP_4_ON:GOTO [MANUAL_RUN] 
PUMP_1_OFF:PUMP_2_OFF:PUMP_3_OFF:PUMP_4_OFF:RETURN



REM '****************************************************
REM '        [DISPLAY_STATUS]
REM '****************************************************
[DISPLAY_STATUS]
REM '   3 
=SEC{}:IF 0<>%3 THEN #(658)=0:RETURN 
IF #(658)=1 THEN RETURN
#(658)=1:#(654)=#(654)+1:CASE #(654),1,[DS_1],2,[DS_2]
CASE #(654),3,[DS_3],4,[DS_4],5,[DS_5],6,[DS_6]
CASE #(654),7,[DS_7],8,[DS_8],9,[DS_9]
#(654)=1
[DS_1]
CLS:IF #(653)=0 THEN LPRINT " .":RETURN
LPRINT .1,"=",T," Min =",D:AT 64
IF #(653)=2 THEN LPRINT "T     ":RETURN
IF #(653)=3 THEN LPRINT "T . . ":RETURN
LPRINT "T  .":RETURN

REM '****************************************************
[DS_2]
CLS:LPRINT " - ":AT 64
IF 0=PUMP_TANK_IN THEN LPRINT "":RETURN
LPRINT " ":RETURN

REM '****************************************************
[DS_3]
CLS:IF #(651)=0 THEN LPRINT " PH ":RETURN
LPRINT .2,"=",H," ",I,"-",J:AT 64
IF #(651)=2 THEN LPRINT "PH . - ":RETURN
IF #(651)=3 THEN LPRINT "PH ..":RETURN
LPRINT "PH  .":RETURN

REM '****************************************************
[DS_4]
CLS:IF #(650)=0 THEN LPRINT " EC ":RETURN
LPRINT .2,"=",E," ",F,"-",G:AT 64
IF #(650)=2 THEN LPRINT "EC .  ":RETURN
IF #(650)=1 THEN LPRINT "EC . ":RETURN
IF #(650)=6 THEN LPRINT "EC    ":RETURN
IF #(650)=7 THEN LPRINT "EC . - 1":RETURN
IF #(650)=8 THEN LPRINT "EC . - 2":RETURN
IF #(650)=9 THEN LPRINT "EC . - 3":RETURN
LPRINT "EC ..":RETURN

[DS_5]
CLS:LPRINT "   ":AT 64
IF 0=WATER_IN THEN LPRINT "   ":RETURN
LPRINT "   ":RETURN

[DS_6]
CLS:LPRINT "  ":AT 64:LPRINT "   "
AT 64:IF 1=INPUT_HI THEN LPRINT "   ":RETURN
LPRINT "   ":RETURN

[DS_7]
CLS:LPRINT "  ":AT 64
IF 1=PUMP_IN_IN THEN LPRINT "  ":RETURN
LPRINT "  ":RETURN

[DS_8]
CLS:LPRINT " ":AT 64
IF 1=HEATER_IN THEN LPRINT "  ":RETURN
LPRINT "  ":RETURN

[DS_9]
CLS:LPRINT " 1:"
IF 1=PUMP_1_IN THEN LPRINT "ON ":AT 64
IF 0=PUMP_1_IN THEN LPRINT "OFF":AT 64
IF 1=PUMP_2_IN THEN LPRINT "2:ON  3:"
IF 0=PUMP_2_IN THEN LPRINT "2:OFF 3:"
IF 1=PUMP_3_IN THEN LPRINT "ON  4:"
IF 0=PUMP_3_IN THEN LPRINT "OFF 4:"
IF 1=PUMP_4_IN THEN LPRINT "ON":RETURN
IF 0=PUMP_4_IN THEN LPRINT "OF":RETURN
REM '****************************************************



REM '****************************************************
REM '        [MENU]
REM '****************************************************
[MENU]
CLS:LPRINT " ":AT 64:LPRINT "Press any key"
PAUSE 100:=KEY{3}:IF =0 THEN GOTO [DISPLAY_STATUS]

GOSUB [INIT_DEVICE]

GOSUB [MENU_TANK]
GOSUB [MENU_TERMO]
GOSUB [MENU_PH]
GOSUB [MENU_EC]

GOTO [RESET]
REM '****************************************************

[CHANGE_PARAM]
IF #(765)=1 THEN i=i+1:IF i>3600 THEN i=3600 
IF #(765)=2 THEN i=i-20:IF i<1 THEN i=1 
IF #(765)=8 THEN i=i+20:IF i>3600 THEN i=3600 
IF #(765)=16 THEN i=i-1:IF i<1 THEN i=1 
RETURN




[START]
REM '****************************************************
REM '              Start system
REM '****************************************************
LINIT 1:BEEP 15,2:UART 1,5:LPRINT "PH-EC Control "
AT 64:LPRINT "V1.5 Start":GOSUB [INIT_DEVICE]
GOSUB [LOAD_CONFIG]
REM '    
PAUSE 10000:GOSUB [INIT_PH]
STEMP 1:GOSUB [INIT_EC]
GOSUB [INIT_TERMO]
REM '****************************************************
REM '              
REM '****************************************************
[MAIN]
REM '   

GOSUB [POLIW_WORK]
GOSUB [TANK_WORK]
GOSUB [TERMO_WORK]
GOSUB [PH_WORK]
GOSUB [EC_WORK]
GOSUB [DISPLAY_STATUS]
IF 4=GKEY{} THEN GOSUB [MENU]
IF 0<>GKEY{} THEN GOSUB [MANUAL_RUN]
GOTO [MAIN]
REM '****************************************************




REM '****************************************************
REM '       
REM '****************************************************

REM '************   ,   ******************
[INIT_DEVICE]
PUMP_1_OFF:PUMP_2_OFF:PUMP_3_OFF:PUMP_4_OFF:T=500
PUMP_IN_OFF:PUMP_TANK_OFF:WATER_ON:HEATER_OFF
TIMER 0,0:TIMER 1,0:TIMER 2,0:TIMER 3,0
TIMER 4,0:TIMER 5,0:TIMER 6,0:TIMER 7,0:RETURN
REM '****************************************************




REM '****************************************************
REM '********         ********************
[LOAD_CONFIG]
REM ' EEPROM      
REM '  8 bit  000 - 040
REM '  8 bit  040 -  
#(600)=RDEE{0}:IF #(600)=73 THEN GOTO [LOAD_CFG]
REM '********    ********************
[SET_DEFAULT_CONFIG]
REM 'CONFIG ok;
#(600)=73:#(601)=0:#(603)=0:#(604)=0:#(605)=0
#(606)=0:#(607)=1:#(608)=0:#(609)=0:#(610)=0:#(612)=1
#(613)=0:#(614)=0:Y=60:Z=120:a=120:b=1200:#(600)=73
O=20:P=60:Q=2:R=4:S=5:U=10:V=30:W=600:X=600
REM '********        ********************
[SAVE_CONFIG]
WREE F,40:WREE G,42:WREE I,44:WREE J,46:WREE #(604),4
WREE L,50:WREE M,52:WREE N,54:WREE O,56:WREE #(608),8
WREE Q,60:WREE R,62:WREE S,64:WREE U,66:WREE b,80
WREE W,70:WREE X,72:WREE Y,74:WREE Z,76:WREE a,78
WREE #(601),1:WREE #(600),0:WREE #(603),3:WREE K,48
WREE #(605),5:WREE #(606),6:WREE #(607),7:WREE P,58
WREE #(609),9:WREE #(610),10:WREE #(612),11:WREE V,68
WREE #(613),12:WREE #(614),13:WREE #(600),0:WREE D,82
RETURN
REM '********       ********************
[LOAD_CFG]
F=RDEE{40}:G=RDEE{42}:I=RDEE{44}:J=RDEE{46}:K=RDEE{48}
L=RDEE{50}:M=RDEE{52}:N=RDEE{54}:O=RDEE{56}:P=RDEE{58}
Q=RDEE{60}:R=RDEE{62}:S=RDEE{64}:U=RDEE{66}:V=RDEE{68}
W=RDEE{70}:X=RDEE{72}:Y=RDEE{74}:Z=RDEE{76}:a=RDEE{78}
#(601)=RDEE{1}:#(603)=RDEE{3}:D=RDEE{82}
#(604)=RDEE{4}:#(605)=RDEE{5}:#(606)=RDEE{6}
#(607)=RDEE{7}:#(608)=RDEE{8}:#(609)=RDEE{9}
#(610)=RDEE{10}:#(612)=RDEE{11}:#(613)=RDEE{12}
#(614)=RDEE{13}:#(600)=RDEE{0}:b=RDEE{80}:RETURN
REM '****************************************************


