REM SUB '*******   PH  TDS      ***************
REM ' ver 1.6 20.02.17
REM '****************************************************
REM '  BASIC DEVICE 3.4.8  
REM '****************************************************
REM '			 
REM 'I/O 1     #4,   
REM 'I/O 2      ,   
REM 'I/O 3     #1 
REM 'I/O 4     #2
REM 'I/O 5     #3
REM 'I/O 6   ,   
REM 'I/O 7     ,   
REM 'I/O 8   
REM 'I/O 9    
REM 'I/O 10     ,  
REM 'I/O 11    ,   
REM 'UART     pH, EC/TDC


REM '  
#define PUMP_1_ON   EQU    PORT 3,1 
#define PUMP_1_OFF  EQU    PORT 3,0
#define PUMP_1_IN  EQU    PORT*{3}

#define PUMP_2_ON   EQU    PORT 4,1 
#define PUMP_2_OFF  EQU    PORT 4,0
#define PUMP_2_IN  EQU    PORT*{4} 

#define PUMP_3_ON   EQU    PORT 5,1 
#define PUMP_3_OFF  EQU    PORT 5,0
#define PUMP_3_IN  EQU    PORT*{5} 

#define PUMP_4_ON   EQU    PORT 1,1 
#define PUMP_4_OFF  EQU    PORT 1,0
#define PUMP_4_IN  EQU    PORT*{1} 

REM '     
#define PUMP_IN_ON  EQU    PORT 2,1 
#define PUMP_IN_OFF EQU    PORT 2,0 
#define PUMP_IN_IN  EQU    PORT*{2} 

REM '     
#define PUMP_TANK_ON  EQU    PORT 9,1 
#define PUMP_TANK_OFF EQU    PORT 9,0 
#define PUMP_TANK_IN EQU    PORT*{9} 

REM '    -  
#define WATER_ON  EQU    PORT 11,1 
#define WATER_OFF EQU    PORT 11,0 
#define WATER_IN EQU    PORT*{11}

REM ' 
#define HEATER_ON  EQU    PORT 6,1 
#define HEATER_OFF EQU    PORT 6,0 
#define HEATER_IN EQU    PORT*{6} 

REM ' ***************************************************
REM '   ,    - 
REM '   IN=0  IN=1
#define INPUT_LO  EQU    PORT{10}
#define INPUT_HI  EQU    PORT{7}


REM ' ***************************************************
REM '      BASIC 
REM '****************************************************
REM ENDSUB  '********************************************


REM SUB  ' *********   VARIABLE  Timer ******************
REM '	TIMER_1    
REM '	TIMER_2     EC
REM '   TIMER_3    PH
REM '   TIMER_4    EC
REM '   TIMER_5    TERMO
REM '   TIMER_6    TANK ADD WATER
REM '   TIMER_7   
REM '   TIMER_0 

REM '      *********   VARIABLE  MEMORY 16 bit  *********

REM ' A -      PH
REM ' 00.0- 50.0; 99.9 - ERROR
REM ' B -      EC
REM ' 00.0- 50.0; 99.9 - ERROR
REM ' C -    
REM ' 00.0- 50.0; 99.9 - ERROR
REM ' D -   

REM ' E -   EC 00.00- 10.00; 99.99 - ERROR
REM ' F -   EC
REM ' G -   EC

REM ' H -   PH 00.00- 15.00; 99.99 - ERROR
REM ' I -   PH
REM ' J -   PH 

REM ' K -     1  PH ()
REM ' L -     1  PH ()
REM ' M -     2  PH 
REM ' N -     2  PH 

REM ' O -   EC  10 
REM ' P -   EC
REM ' Q -  1  EC
REM ' R -  2  EC
REM ' S -  3  EC

REM ' T -    
REM '     (  PH/EC/INT  )

REM ' U -     EC  
REM ' V -     EC  

REM ' W -     - 
REM ' X -     EC - 

REM ' Y -  -   
REM ' Z -  -   

REM '  -    
REM ' b -    

REM ' c
REM ' d
REM ' e
REM ' f
REM ' g
REM ' h

REM ' i -  
REM ' ******* 8 bit *************************************

REM '#(600) CONFIF STATUS 
REM '       = 73 - ok, ELSE Bad CONFIG 

REM '       
REM '#(601) -   
REM '       - 0 -  1 - 
REM '#(602) -    NOT USE
REM '       - 0 -  1 - 

REM '      
REM '#(603) - 0 -  1 - ( )
REM '#(604) -   
REM '       - 0 INT; 1 - PH; 2 - EC 
REM '#(605) -   
REM '       - 0 -  1 - 

REM '       PH
REM '#(606) - 0 -  1 - ( )
REM '#(607) - 0   #1  #4   
REM '         1   #1   
REM '         2   #1   
REM '#(608) -   
REM '       - 0 -  1 - 
REM '#(609) -   
REM '       - 0 -  1 - 

REM '      EC
REM '#(610) - 0 -  1 - ( )
REM '#(611) - 0 -  1 - ( PH)
REM '#(612) - 2     #2  #3    
REM '         1     #2
REM '         3     #2  #3  #4
REM '#(613) -   
REM '       - 0 -  1 - 
REM '#(614) -   
REM '       - 0 -  1 - 

REM ' ********   end Config  ****************************

REM '#(650) -    EC
REM '   =0 -  
REM '   =1 -  ,    
REM '   =2 -      
REM '   =3 -   
REM '   =4 -    
REM '   =5 -   
REM '   =6 -  
REM '   =7 -   1
REM '   =8 -   2
REM '   =9 -   3
REM '   =10 - 


REM '#(651) -    PH
REM '   =0 -  
REM '   =1 -  ,    
REM '   =2 -  
REM '   =3 -  
REM '   =4 -     ->2 OR ->1


REM '#(652) -   
REM '   =0 - 
REM '   =1 - 

REM '#(653) -    
REM '   =0 -  
REM '   =1 -  ,    
REM '   =2 -  
REM '   =3 -  
REM '   =4 -     

REM '#(654) -    
REM '#(655) - FLAG PH 
REM '#(656) - FLAG EC
REM '#(657) - FLAG TERMO
REM '#(658) - FLAG DISPLAY


REM '#(700) - #(764)  
REM '#(765) -  

REM '#(770) - #(789)  
REM '#(790) - #(799)  
REM '#(800) - #(809)  
REM ENDSUB  '********************************************

REM SUB ' ************ RAM  *****************************
REM '     
REM '#(992) -  USE
REM '****************************************************
REM ENDSUB  '********************************************


0000
[RESET]
CLR:NOERR 1:GOTO [START]
REM 'CLR:GOTO [START]
REM '**    
0001
CLR:LINIT 1:LPRINT "RESTART":PAUSE 1000:NOERR 1
REM ' DEBUG
STOP:GOTO [START]

#include TANK_CONTROL.BAS
#include TERMO_CONTROL.BAS
#include PH_CONTROL.BAS
#include EC_CONTROL.BAS
#include CONTROL_SUB.BAS

[START]
REM '****************************************************
REM '              Start system
REM '****************************************************
LINIT 1:BEEP 15,2:UART 1,5:LPRINT "PH-EC Control "
AT 64:LPRINT "V1.5 Start":GOSUB [INIT_DEVICE]
GOSUB [LOAD_CONFIG]
REM '    
PAUSE 10000:GOSUB [INIT_PH]
STEMP 1:GOSUB [INIT_EC]
GOSUB [INIT_TERMO]
REM '****************************************************
REM '              
REM '****************************************************
[MAIN]
REM '   

GOSUB [POLIW_WORK]
GOSUB [TANK_WORK]
GOSUB [TERMO_WORK]
GOSUB [PH_WORK]
GOSUB [EC_WORK]
GOSUB [DISPLAY_STATUS]
IF 4=GKEY{} THEN GOSUB [MENU]
IF 0<>GKEY{} THEN GOSUB [MANUAL_RUN]
GOTO [MAIN]
REM '****************************************************




REM '****************************************************
REM '       
REM '****************************************************

REM '************   ,   ******************
[INIT_DEVICE]
PUMP_1_OFF:PUMP_2_OFF:PUMP_3_OFF:PUMP_4_OFF:T=500
PUMP_IN_OFF:PUMP_TANK_OFF:WATER_ON:HEATER_OFF
TIMER 0,0:TIMER 1,0:TIMER 2,0:TIMER 3,0
TIMER 4,0:TIMER 5,0:TIMER 6,0:TIMER 7,0:RETURN
REM '****************************************************




REM '****************************************************
REM '********         ********************
[LOAD_CONFIG]
REM ' EEPROM      
REM '  8 bit  000 - 040
REM '  8 bit  040 -  
#(600)=RDEE{0}:IF #(600)=73 THEN GOTO [LOAD_CFG]
REM '********    ********************
[SET_DEFAULT_CONFIG]
REM 'CONFIG ok;
#(600)=73:#(601)=0:#(603)=0:#(604)=0:#(605)=0
#(606)=0:#(607)=1:#(608)=0:#(609)=0:#(610)=0:#(612)=1
#(613)=0:#(614)=0:Y=60:Z=120:a=120:b=1200:#(600)=73
O=20:P=60:Q=2:R=4:S=5:U=10:V=30:W=600:X=600
REM '********        ********************
[SAVE_CONFIG]
WREE F,40:WREE G,42:WREE I,44:WREE J,46:WREE #(604),4
WREE L,50:WREE M,52:WREE N,54:WREE O,56:WREE #(608),8
WREE Q,60:WREE R,62:WREE S,64:WREE U,66:WREE b,80
WREE W,70:WREE X,72:WREE Y,74:WREE Z,76:WREE a,78
WREE #(601),1:WREE #(600),0:WREE #(603),3:WREE K,48
WREE #(605),5:WREE #(606),6:WREE #(607),7:WREE P,58
WREE #(609),9:WREE #(610),10:WREE #(612),11:WREE V,68
WREE #(613),12:WREE #(614),13:WREE #(600),0:WREE D,82
RETURN
REM '********       ********************
[LOAD_CFG]
F=RDEE{40}:G=RDEE{42}:I=RDEE{44}:J=RDEE{46}:K=RDEE{48}
L=RDEE{50}:M=RDEE{52}:N=RDEE{54}:O=RDEE{56}:P=RDEE{58}
Q=RDEE{60}:R=RDEE{62}:S=RDEE{64}:U=RDEE{66}:V=RDEE{68}
W=RDEE{70}:X=RDEE{72}:Y=RDEE{74}:Z=RDEE{76}:a=RDEE{78}
#(601)=RDEE{1}:#(603)=RDEE{3}:D=RDEE{82}
#(604)=RDEE{4}:#(605)=RDEE{5}:#(606)=RDEE{6}
#(607)=RDEE{7}:#(608)=RDEE{8}:#(609)=RDEE{9}
#(610)=RDEE{10}:#(612)=RDEE{11}:#(613)=RDEE{12}
#(614)=RDEE{13}:#(600)=RDEE{0}:b=RDEE{80}:RETURN
REM '****************************************************


